unit Autoatlas_U;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ActnList, ExtCtrls, ComCtrls, StdCtrls;

type

  TCesta=Record
    Odkud,Kam:String;
    Vzdalenost,PRychlost:LongInt;
    end;

  TCesty=Record
    Pocet:LongInt;
    Data:Array of TCesta;
    end;

  TMesto=Record
    Jmeno:String;
    Pozice:TPoint;
    NaMape:TPoint;
    Cesty:TCesty;
    end;

  TMesta=record
    Data:Array of TMesto;
    Pocet:LongInt;
    end;

  TFindData=Record
    Mesta:Array of Integer;
    Pocet:LongInt;
    Kam:Integer;
    end;

  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    Soubor1: TMenuItem;
    Otevt1: TMenuItem;
    N1: TMenuItem;
    Konec1: TMenuItem;
    ActionList1: TActionList;
    OtevriAct: TAction;
    KonecAct: TAction;
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    ScrollBox1: TScrollBox;
    OpenDialog1: TOpenDialog;
    Label1: TLabel;
    ListCities: TListBox;
    Zobrazen1: TMenuItem;
    UkazMapuAct: TAction;
    ZobrazCestyAct: TAction;
    Ukzatmsta1: TMenuItem;
    ScrollBox2: TScrollBox;
    Image1: TImage;
    Panel2: TPanel;
    Ukzatcesty1: TMenuItem;
    Button1: TButton;
    Button2: TButton;
    procedure OtevriActExecute(Sender: TObject);
    procedure UkazMapuActExecute(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure KonecActExecute(Sender: TObject);
    procedure ZobrazCestyActExecute(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    Mesta:TMesta;
    Cesty:TCesty;
  public
    procedure vyhledat(odkud,kam,kriterium:integer);
    Function FindPath(odkud:integer;var FindData:TFindData):boolean;
  end;

var
  Form1: TForm1;

implementation

uses OkolniMesta_U, VyberTrasy_U;

{$R *.dfm}

// vrati hodnotu z radku
function GetData(Source,Tag:String):String;
begin
  Result:=Copy(Source,Pos('<'+tag+'>',Source)+Length(tag)+2,Length(Source)-(Pos('<'+tag+'>',Source)+(Length(tag)+2)*2));
end;

//nacte mesta
function LoadFromFile_C(FileName:String;var Mesta:TMesta):Word;
Var F:TextFile;
    i:Integer;
    S:String;
    Nazev,polohaX,polohaY:String;
begin
  Mesta.Pocet:=-1;
  SetLength(Mesta.Data,0);
  If FileExists(FileName) then
  begin
    AssignFile(F,FileName);
    Reset(F);

    While (Pos('<mesta>',S)=0)and not Eof(F) do ReadLn(F,S); //Preskoceni ostatnich nepotrebnych radku
    If Pos('<mesta>',S)>0 then
    begin
      While (Pos('</mesta>',S)=0)and not Eof(F) do //nacitani az do konce sekce "mesta"
      begin
        ReadLn(F,S);

        If Pos('<mesto>',S)>0 then begin
          Inc(Mesta.Pocet);
          end;

        If Pos('<nazev>',S)>0 then
          nazev:=GetData(S,'nazev');

        If Pos('<polohaX>',S)>0 then
          polohaX:=GetData(S,'polohaX');

        If Pos('<polohaY>',S)>0 then
          polohaY:=GetData(S,'polohaY');

        If Pos('</mesto>',S)>0 then
          with Mesta do
          begin
            SetLength(Data,Pocet+1);
            Data[Pocet].Jmeno:=nazev;
            Data[Pocet].Pozice.X:=StrToInt(PolohaX);
            Data[Pocet].Pozice.Y:=StrToInt(PolohaY);
            end;

        end;
      end;
    CloseFile(F);
    Result:=0;
    end
    else Result:=1;
end;


//nacte cesty
function LoadFromFile_R(FileName:String;var Cesty:TCesty):Word;
Var F:TextFile;
    i:Integer;
    S:String;
    Z,
    PRychlost,
    Vzdalenost,
    Kam:String;

begin
  Cesty.Pocet:=-1;
  SetLength(Cesty.Data,0);
  If FileExists(FileName) then
  begin
    AssignFile(F,FileName);
    Reset(F);

    While (Pos('<cesty>',S)=0)and not Eof(F) do ReadLn(F,S); //Preskoceni ostatnich nepotrebnych radku
    If Pos('<cesty>',S)>0 then
    begin
      While (Pos('</cesty>',S)=0)and not Eof(F) do //nacitani az do konce sekce "Cesty"
      begin
        ReadLn(F,S);

        If Pos('<cesta>',S)>0 then begin
          Inc(Cesty.Pocet);
          end;

        If Pos('<z>',S)>0 then
          z:=GetData(S,'z');
        If Pos('<do>',S)>0 then
          kam:=GetData(S,'do');
        If Pos('<vzdalenost>',S)>0 then
          Vzdalenost:=GetData(S,'vzdalenost');
        If Pos('<prumernaRychlost>',S)>0 then
          PRychlost:=GetData(S,'prumernaRychlost');

        If Pos('</cesta>',S)>0 then
          with Cesty do
          begin
            SetLength(Data,Pocet+1);
            Data[Pocet].Odkud:=z;
            Data[Pocet].Kam:=Kam;
            Data[Pocet].Vzdalenost:=StrToInt(Vzdalenost);
            Data[Pocet].PRychlost:=StrToInt(PRychlost);

            end;

        end;
      end;
    CloseFile(F);
    Result:=0;
    end
    else Result:=1;
end;



//otevre soubor, vytvori mesta, cesty, u kazdeho mesty vytvori seznam cest, ktere z nej vedou
procedure TForm1.OtevriActExecute(Sender: TObject);
Var i,j:Integer;
begin
  If OpenDialog1.Execute then
  begin
    Case LoadFromFile_C(OpenDialog1.FileName,Mesta) of
      0:begin
          ListCities.Items.Clear;
          For i:=0 to Mesta.Pocet do begin
            ListCities.Items.Add(Mesta.Data[i].Jmeno);
            end;


          LoadFromFile_R(OpenDialog1.FileName,Cesty);

          for i:=0 to Mesta.Pocet do
          begin
            Mesta.Data[i].Cesty.Pocet:=-1;
            for j:=0 to Cesty.Pocet do
            begin
              If Cesty.Data[j].Odkud=Mesta.Data[i].Jmeno then
                begin
                  Inc(Mesta.Data[i].Cesty.Pocet);
                  SetLength(Mesta.Data[i].Cesty.Data,Mesta.Data[i].Cesty.Pocet+1);
                  Mesta.Data[i].Cesty.Data[Mesta.Data[i].Cesty.Pocet]:=Cesty.Data[j];
                  end;
              If Cesty.Data[j].Kam=Mesta.Data[i].Jmeno then
                begin
                  Inc(Mesta.Data[i].Cesty.Pocet);
                  SetLength(Mesta.Data[i].Cesty.Data,Mesta.Data[i].Cesty.Pocet+1);
                  Mesta.Data[i].Cesty.Data[Mesta.Data[i].Cesty.Pocet]:=Cesty.Data[j];
                  Mesta.Data[i].Cesty.Data[Mesta.Data[i].Cesty.Pocet].Kam:=Mesta.Data[i].Cesty.Data[Mesta.Data[i].Cesty.Pocet].Odkud;
                  Mesta.Data[i].Cesty.Data[Mesta.Data[i].Cesty.Pocet].Odkud:=Mesta.Data[i].Jmeno;
                  end;

              end;
            end;
          UkazMapuAct.Enabled:=TRUE;
          UkazMapuAct.Execute;
          UkzatCesty1.Enabled:=TRUE;
          Button1.Enabled:=TRUE;
          Button2.Enabled:=TRUE;
          end;
      1:MessageBox(Form1.Handle,'Zadan soubor nelze otevt','Chyba',MB_ICONASTERISK);
      end;
    end;
end;

//zobrazi mapu PS:souradnice Liberce je spatne v XML, ne spatne zobrazena
procedure TForm1.UkazMapuActExecute(Sender: TObject);
var i:Integer;
    MinPos,MaxPos:TPoint;
begin
  //nalezen nejmen/nejvt pozice msta pro velikost oblasti ke kresleni
  If Mesta.Pocet>-1 then begin
    MinPos.X:=0;
    MaxPos.X:=0;
    MinPos.Y:=0;
    MaxPos.Y:=0;

    for i:=0 to Mesta.Pocet do
      With Mesta.Data[i] do
      begin
        If Pozice.X<MinPos.X then MinPos.X:=Pozice.X;
        If Pozice.X>MaxPos.X then MaxPos.X:=Pozice.X;
        If Pozice.Y<MinPos.Y then MinPos.Y:=Pozice.Y;
        If Pozice.Y>MaxPos.Y then MaxPos.Y:=Pozice.Y;
        end;

    Panel2.Visible:=TRUE;
    Panel2.Left:=0;
    Panel2.Top:=0;
    Panel2.Width:=(Abs(MaxPos.X)+Abs(MinPos.X))*2+100;
    Panel2.Height:=(Abs(MaxPos.Y)+Abs(MinPos.Y))*2+100;
    Image1.Left:=0;
    Image1.Top:=0;
    Image1.Width:=Panel2.Width;
    Image1.Height:=Panel2.Height;
    With Image1.Canvas do
    begin
      Brush.Color:=clWhite;
      Rectangle(Image1.ClientRect);

      for i:=0 to Mesta.Pocet do
        With Mesta.Data[i] do
        begin
          NaMape.X:=(Pozice.X-MinPos.X)*2+50;
          NaMape.Y:=(Pozice.Y-MinPos.Y)*2+50;
          Pen.Color:=clBlack;
          Brush.Color:=clGray;
          Ellipse(NaMape.X-5,NaMape.Y-5,NaMape.X+5,NaMape.Y+5);
          Brush.Color:=clYellow;
          TextOut(NaMape.X-TextWidth(Jmeno) div 2,NaMape.Y+5,Jmeno);
          end;
        end;
    If UkzatCesty1.Checked then ZobrazCestyAct.Execute;
  end
  else MessageBox(Form1.Handle,'V databzi nejsou dn msta','Chyba',MB_ICONASTERISK);

end;

//nastavi pocatecni hodnoty
procedure TForm1.FormCreate(Sender: TObject);
begin
  UkazMapuAct.Enabled:=FALSE;
  Mesta.Pocet:=-1;
  Cesty.Pocet:=-1;
  Button1.Enabled:=FALSE;
end;

//vyhleda okolni mesta a vyvola okno s vysledky
procedure TForm1.Button1Click(Sender: TObject);
Var i,j:Integer;
    cas:LongInt;

begin
  i:=-1;
  Repeat
    inc(i);
  Until (i+1=ListCities.Items.Count)or ListCities.Selected[i];
  If ListCities.Selected[i] then
  begin
    Form2.Label3.Caption:=ListCities.Items.Strings[i];
    For j:=0 to Mesta.Data[i].Cesty.Pocet do
    begin
      Form2.StringGrid1.Cells[0,j+1]:=Mesta.Data[i].Cesty.Data[j].Kam;
      Form2.StringGrid1.Cells[1,j+1]:=IntToStr(Mesta.Data[i].Cesty.Data[j].Vzdalenost);
      Form2.StringGrid1.Cells[2,j+1]:=IntToStr(Mesta.Data[i].Cesty.Data[j].PRychlost);

      cas:=Round(Mesta.Data[i].Cesty.Data[j].Vzdalenost/Mesta.Data[i].Cesty.Data[j].PRychlost*3600);
      Form2.StringGrid1.Cells[3,j+1]:=IntToStr(cas div 3600)+'h:'+IntToStr(cas mod 3600 div 60)+'m:'+
                                      IntToStr(cas mod 3600 mod 60)+'s';
      ;

      end;
    Form2.Show;

    end
    else
      MessageBox(Form1.Handle,'Muste si vybrat msto ze seznamu','Chyba',MB_ICONERROR);

end;

//konec programu
procedure TForm1.KonecActExecute(Sender: TObject);
begin
  If MessageBox(Form1.Handle,'Opravdu chcete skonit?','Konec programu',MB_YESNO or MB_ICONQUESTION)=IDYES then Close;
end;

//nakresli cesty na mapu
procedure TForm1.ZobrazCestyActExecute(Sender: TObject);
var i,j:Integer;
    closed,bBod1,bBod2:Boolean;
    Bod1,Bod2:TPoint;
    MinSp,MaxSp:LongInt;
begin
  If UkzatCesty1.Checked then begin
    MinSp:=0;
    MaxSp:=0;

    for i:=0 to Cesty.Pocet do
    begin
      If MinSp>Cesty.Data[i].PRychlost then MinSp:=Cesty.Data[i].PRychlost;
      If MaxSp<Cesty.Data[i].PRychlost then MaxSp:=Cesty.Data[i].PRychlost;
      end;


    With Image1.Canvas do
    begin
      for i:=0 to Cesty.Pocet do
        With Cesty.Data[i] do
         begin
           closed:=FALSE;
           j:=-1;
           bBod1:=FALSE;
           bBod2:=FAlse;
           repeat
             Inc(j);
             If Mesta.Data[j].Jmeno=Odkud then
             begin
               Bod1:=Mesta.Data[j].NaMape;
               bBod1:=TRUE;
               end;
             If Mesta.Data[j].Jmeno=Kam then
             begin
               Bod2:=Mesta.Data[j].NaMape;
               bBod2:=TRUE;
               end;
             Closed:=bBod1 and bBod2;
           until Closed or (j=Mesta.Pocet);


           If Closed then begin
             Pen.Color:=Round(PRychlost/(MaxSp-MinSp)*255)+Round((MaxSp-PRychlost)/(MaxSp-MinSp)*256)*256;
             MoveTo(Bod1.X,Bod1.Y);
             LineTo(Bod2.X,Bod2.Y);
             end;
        end;
      end;
  end;  

end;

//vyvola dialog pro vyber kriterii
procedure TForm1.Button2Click(Sender: TObject);
Var i:Integer;
begin
  Form3.ComboBox1.Items.Clear;
  Form3.ComboBox2.Items.Clear;
  for i:=0 to Mesta.Pocet do
  begin
    Form3.ComboBox1.Items.Add(Mesta.Data[i].Jmeno);
    Form3.ComboBox2.Items.Add(Mesta.Data[i].Jmeno);
    end;
  Form3.Combobox1.ItemIndex:=0;
  Form3.Combobox2.ItemIndex:=1;
  Form3.Show;
end;


//nalezne cestu, hleda rekurzivne, pamatuje si v FindData mesta, kam uz sel (aby
//necykloval stale dokola)
Function TForm1.FindPath;
var i:Integer;
    j,k:Integer;
    Possible:Boolean;
begin
  Inc(FindData.Pocet);
  SetLength(FindData.Mesta,FindData.Pocet+1);
  FindData.Mesta[FindData.Pocet]:=Odkud;

  for i:=0 to Mesta.Data[odkud].Cesty.Pocet do
  begin
    j:=-1;
    repeat
      inc(j);
    until (j=Mesta.Pocet)or(Mesta.Data[j].Jmeno=Mesta.Data[odkud].Cesty.Data[i].Kam);
    if Mesta.Data[j].Jmeno=Mesta.Data[odkud].Cesty.Data[i].Kam then
    begin
      if j=FindData.Kam then
      begin
        Result:=TRUE;
        Inc(FindData.Pocet);
        SetLength(FindData.Mesta,FindData.Pocet+1);
        FindData.Mesta[FindData.Pocet]:=j;
        end
        else begin
          Possible:=TRUE;
          For k:=0 to FindData.Pocet do
            If FindData.Mesta[k]=j then Possible:=FALSE;

          if possible then
            result:=FindPath(j,FindData);
          end;
      end;
    
    end;
end;

//procedura pro vyhledavani cesty podle kriterii, z nedostatku casu pouze vypisu
//data nefiltrovana z FindData - dusledkem rekurze na sebe nenavazuji
Procedure TForm1.vyhledat;
Var FindData:TFindData;
    S:String;
    i:Integer;
begin
{  Case Kriterium of
    0:begin//nejkrat}
      FindData.Kam:=Kam;
      FindData.Pocet:=-1;
      If FindPath(Odkud,FindData) then
      begin
        S:='';
        for i:=0 to FindData.Pocet do begin
          S:=S+Mesta.Data[FindData.Mesta[i]].Jmeno+';';
          if i mod 10=0 then
            S:=s+#13+#10;
          end;
        ShowMessage('Trasa:'+#13+#10+S);
        end;
{      end;
    1:Begin
      end;
    2:begin
      end;
    end;  }
end;

end.
